package org.one.stone.soup.clipboard;

import java.io.*;
import java.awt.datatransfer.*;

/*
 * Wet-Wired.com Library Version 2.1
 *
 * Copyright 2000-2001 by Wet-Wired.com Ltd.,
 * Portsmouth England
 * This software is OSI Certified Open Source Software
 * This software is covered by an OSI approved open source licence
 * which can be found at http://www.onestonesoup.org/OSSLicense.html
 */

 /**
	* The ClipboardHelper, as its name implies gives a number of helper methods
	* that ease the use of the Java Clipboard.
	* It only supports the use of text clips.
	*
	* All the functions are static, so no instance of ClipboardHelper need be
	* created to use the functions.
	*
*/

public class ClipboardHelper {
public static String fromClipboard() {

 try{
	Clipboard clipB = org.one.stone.soup.grfx.ImageFactory.DUMMY.getToolkit().getSystemClipboard();

	Transferable dataT = clipB.getContents(null);
/*	DataFlavor[] flavors = dataT.getTransferDataFlavors();
	for(int loop=0;loop<flavors.length;loop++)
	{
		System.out.println( flavors[loop].getMimeType()+" : "+flavors[loop].getHumanPresentableName() );
	}*/
	StringBuffer data = new StringBuffer();
	Object dataTr = dataT.getTransferData(DataFlavor.stringFlavor);

	if(dataTr instanceof String)
	{
		data.append(dataTr.toString());
	}
	else if(dataTr instanceof StringReader)
	{
	StringReader dataR = (StringReader)dataTr;

	int in = dataR.read();

	while(in!=-1)
	{
		data.append((char)in);

		in = dataR.read();
	}
	}
	return data.toString();
 }
 catch(Exception e)
 {
	 return null;
 }
}
public static void toClipboard(String data) {

	Clipboard clipB = org.one.stone.soup.grfx.ImageFactory.DUMMY.getToolkit().getSystemClipboard();

	StringSelection dataS = new StringSelection(data);

	clipB.setContents(dataS,dataS);
}
}
