package org.one.stone.soup.grfx;

import java.awt.*;
import java.awt.image.*;

/*
 * Wet-Wired.com Library Version 2.1
 *
 * Copyright 2000-2001 by Wet-Wired.com Ltd.,
 * Portsmouth England
 * This software is OSI Certified Open Source Software
 * This software is covered by an OSI approved open source licence
 * which can be found at http://www.onestonesoup.org/OSSLicense.html
 */

/**
 * @author nikcross
 *
 */

// TODO
public class ImageCombiner{

	private static Pixel pixelA = new Pixel();
	private static Pixel pixelB = new Pixel();
	private static Pixel pixelC = new Pixel();
public static Image filter(Image canvas,int x,int y,Image image,float factor,Component owner) {

	if(canvas==null)
		return image;

	int w = image.getWidth(owner);
	int h = image.getHeight(owner);
	int scan = w;
	int size = w*h;
	int[] cData = new int[size];
	int[] data = new int[size];

	PixelGrabber cGrab = new PixelGrabber(canvas,x,y,w,h,cData,0,scan);
	try{cGrab.grabPixels();}catch(Exception e){}

	PixelGrabber pGrab = new PixelGrabber(image,0,0,w,h,data,0,scan);
	try{pGrab.grabPixels();}catch(Exception e){}

	int[] newData = ImageCombiner.process(cData,data,w,h,factor);

	MemoryImageSource mis = new MemoryImageSource(w,h,newData,0,scan);

	return owner.getToolkit().createImage(mis);
}
public static int[] process(int[]cData, int[] data, int w, int h, float factor) {
	int[] result = new int[data.length];

	int fA = (int)((1-factor) * 100);
	int fB = (int)(factor * 100);

	for(int loop=0;loop<data.length;loop++)
	{
		pixelA.setRGB( cData[loop] );
		pixelB.setRGB( data[loop] );

		if(pixelB.alpha==0)
		{
			result[loop] = data[loop];//cData[loop];
		}
		else
		{
			pixelC.alpha = (pixelA.alpha + pixelB.alpha)/2;
			pixelC.red = ((pixelA.red*fA) + (pixelB.red*fB))/100;
			pixelC.green = ((pixelA.green*fA) + (pixelB.green*fB))/100;
			pixelC.blue = ((pixelA.blue*fA) + (pixelB.blue*fB))/100;
			result[loop] = pixelC.getRGB();
		}
	}

	return result;
}
}
