package org.one.stone.soup.mjdb.data.field;

/*
 * MJDB (Micro Java Database) Version 1.0
 *
 * Copyright 2000-2001 by Wet-Wired.com Ltd.,
 * Portsmouth England
 * This software is OSI Certified Open Source Software
 * This software is covered by an OSI approved open source licence
 * which can be found at http://www.wet-wired.com/licence/license-os.html
 */

/**
	* The TimeField class is a wrapper for a time value.
	* @author Nik Cross
*/

public class TimeField extends Field {
	public static String DEFAULT_ID = "_Time";

	private int hours=0;
	private int minutes=0;
	private int seconds=0;
public TimeField()
{
	java.util.Calendar cal = java.util.Calendar.getInstance();
	hours = cal.get(java.util.Calendar.HOUR_OF_DAY);
	minutes = cal.get(java.util.Calendar.MINUTE);
	seconds = cal.get(java.util.Calendar.SECOND);
}
public TimeField(int hours, int minutes, int seconds) {

	this.hours=hours;
	this.minutes=minutes;
	this.seconds=seconds;
}
public TimeField(String data) {}
public int compare(Field target) throws CompareException {
	return 0;
}
/**
 *
 * @return java.lang.String
 */
public String getHours() {
	if(hours<10)
		return "0"+hours;
	else
		return ""+hours;
}
/**
 *
 * @return java.lang.String
 */
public String getMinutes() {
	if(minutes<10)
		return "0"+minutes;
	else
		return ""+minutes;
}
/**
 *
 * @return java.lang.String
 */
public String getSeconds() {
	if(seconds<10)
		return "0"+seconds;
	else
		return ""+seconds;
}
public String getValue(String name) {
	return null;
}
public void setValue(String name, String value, Object source) throws LockException {}
public String toString() {

	return getHours()+":"+getMinutes()+":"+getSeconds();
}

public TimeField(long time) {

	java.util.Date date = new java.util.Date(time);

	java.util.Calendar cal = java.util.Calendar.getInstance();

	this.hours=cal.get(java.util.Calendar.HOUR);
	this.minutes=cal.get(java.util.Calendar.MINUTE);
	this.seconds=cal.get(java.util.Calendar.SECOND);
}
}
