package org.one.stone.soup.server;

import java.net.*;
import java.awt.event.*;

import org.one.stone.soup.util.*;
//import org.one.stone.soup.metro.manager.*;

/*
	Breaks the Metro server thread to allow further processing in Metro.
	Passes the received socket back to the stations route method
*/

public class RouterThread implements Runnable,ActionListener{
	private TimeWatch timer;
	private long ttl;

	private Server server;
	private Socket socket;

	private Thread thread;
/**
 * MultiThreadRouter constructor comment.
 */
public RouterThread( Server metro,Socket socket,long ttl )
{
	this.server = metro;
	this.socket = socket;

	thread = new Thread(this,"Router thread for "+socket);
	thread.start();
}
public void actionPerformed(ActionEvent e)
{
	try{
		thread.setName( "KILLED "+thread.getName() );
		socket.close();
	}
	catch(Exception ex)
	{
	}
}
public void run()
{
	if(ttl>0)
	{
		timer = new TimeWatch(ttl);
		timer.start();
	}

	server.route( socket,this );

	if(timer!=null)
	{
		timer.stop();
	}
}
public void stopTimer()
{
	if(timer!=null)
	{
		timer.stop();
		timer = null;
	}
}
}
