package org.one.stone.soup.swing;

import javax.swing.*;


import java.awt.event.*;
import java.util.*;

/*
 * Wet-Wired.com Library Version 2.1
 *
 * Copyright 2000-2001 by Wet-Wired.com Ltd.,
 * Portsmouth England
 * This software is OSI Certified Open Source Software
 * This software is covered by an OSI approved open source licence
 * which can be found at http://www.onestonesoup.org/OSSLicense.html
 */

/**
 * @author nikcross
 *
 */

public class JAddressField extends JComboBox{
	private Vector listeners = new Vector();
	private Hashtable list = new Hashtable();

public JAddressField() {
	super();

	setEditable(true);
	addActionListener(this);
}

public void addListener(CommandListener listener)
{
	listeners.addElement( listener );
}

public void actionPerformed(ActionEvent e)
{
	if(e.getActionCommand().equals("comboBoxChanged"))
	{
		return;
	}

	sendCommand(""+e.getActionCommand());
	loadCommand(""+e.getActionCommand());
}

public void loadCommand(String command)
{
	if(command==null || list.get(command)!=null)
	{
		return;
	}

	list.put(command,command);
	addItem(command);
}

public void sendCommand(String command)
{
	for(int loop=0;loop<listeners.size();loop++)
	{
		CommandListener listener = (CommandListener)listeners.elementAt(loop);
		listener.parseCommand( command );
	}
}
}

