package org.one.stone.soup.swing;

import javax.swing.*;
import java.awt.event.*;
import java.util.*;

/*
 * Wet-Wired.com Library Version 2.1
 *
 * Copyright 2000-2001 by Wet-Wired.com Ltd.,
 * Portsmouth England
 * This software is OSI Certified Open Source Software
 * This software is covered by an OSI approved open source licence
 * which can be found at http://www.onestonesoup.org/OSSLicense.html
 */

/**
 * @author nikcross
 *
 */

// TODO
public class JCommandField extends JTextField implements KeyListener{
	private Vector listeners = new Vector();
	private Vector commands = new Vector();
	private int commandCursor = 0;
	private boolean localEcho = false;

/**
 * DosKeyField constructor comment.
 */
public JCommandField() {
	super();

	addKeyListener( this );
}
/**
 * DosKeyField constructor comment.
 * @param columns int
 */
public JCommandField(int columns) {
	super(columns);
}
/**
 * DosKeyField constructor comment.
 * @param text java.lang.String
 */
public JCommandField(String text) {
	super(text);
}
/**
 * DosKeyField constructor comment.
 * @param text java.lang.String
 * @param columns int
 */
public JCommandField(String text, int columns) {
	super(text, columns);
}
public void addListener(CommandListener listener)
{
	listeners.addElement( listener );
}
	public void commandDown()
	{
			if(commandCursor<(commands.size()-1))
			{
				commandCursor++;
				setText((String)commands.elementAt(commandCursor));
			}
			else
			{
				setText("");
			}
	}
	public void commandUp()
	{
			if(commandCursor>0)
				commandCursor--;

			setText((String)commands.elementAt(commandCursor));
	}
public Vector getCommands()
{
	return commands;
}
public boolean getLocalEcho() {
	return localEcho;
}
public void keyPressed(KeyEvent k) {

	int code = k.getKeyCode();

	switch(code)
	{
		case KeyEvent.VK_DOWN:
			commandDown();
			break;
		case KeyEvent.VK_UP:
			commandUp();
			break;
	}

	char val = k.getKeyChar();

	switch(val)
	{
		case 10: // return
			loadCommand( getText() );
			sendCommand( getText() );
			if(localEcho) System.out.println( getText() );
			setText( "" );
			break;
		case 8: // delete
			//ignorNextChange=true;
		default:
			/*if( !ignorNextChange )
				controller.matchCommand(textField.getText() );*/
			break;
	}

}
/**
 * keyReleased method comment.
 */
public void keyReleased(KeyEvent e) {}
/**
 * keyTyped method comment.
 */
public void keyTyped(KeyEvent e) {}
public void loadCommand(String command)
{
	for(int loop=0;loop<commands.size();loop++)
	{
		String data = (String)commands.elementAt(loop);
		if(data.equals(command))
		{
			commands.removeElementAt(loop);
			commands.addElement(data);
			commandCursor=commands.size();
			return;
		}
	}

	commands.addElement(command);
	commandCursor=commands.size();
}
public void sendCommand(String command)
{
	for(int loop=0;loop<listeners.size();loop++)
	{
		CommandListener listener = (CommandListener)listeners.elementAt(loop);
		listener.parseCommand( command );
	}
}
/**
 *
 * @param newLocalEcho boolean
 */
public void setLocalEcho(boolean newLocalEcho) {
	localEcho = newLocalEcho;
}
}
