/*
 * Created on 05-Aug-05
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package org.one.stone.soup.swing;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Hashtable;
import java.util.Vector;

import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;

import org.one.stone.soup.stringhelper.StringArrayHelper;

	public class ListConsole extends JRootFrame implements ActionListener
	{

		private JTextConsole textConsole;
		public ListConsole(Vector list)
		{
			super("List View",new String[]{});

			textConsole = new JTextConsole();
			textConsole.setBackground(new Color(0,40,0));
			textConsole.setForeground(new Color(50,250,50));
			textConsole.getComponent().setFont( new Font("Courier",Font.BOLD,14) );

			getContentPane().add(textConsole,BorderLayout.NORTH);

			JMenuItem clear = new JMenuItem( "Clear" );
			clear.addActionListener(this);

			JMenuItem find = new JMenuItem( "Find" );
			find.addActionListener(this);

			JMenuItem replace = new JMenuItem( "Replace" );
			replace.addActionListener(this);

			JMenuItem distinct = new JMenuItem( "Distinct" );
			distinct.addActionListener(this);

			JMenuItem ascending = new JMenuItem( "Sort Ascending" );
			ascending.addActionListener(this);

			JMenuItem descending = new JMenuItem( "Sort Descending" );
			descending.addActionListener(this);


			JMenu edit = new JMenu("Edit");
			edit.add(clear);
			edit.add(find);
			edit.add(replace);

			JMenu sort = new JMenu("Sort");
			sort.add(distinct);
			sort.add(ascending);
			sort.add(descending);

			JMenuBar menuBar = new JMenuBar();
			menuBar.add(edit);
			menuBar.add(sort);

			setJMenuBar( menuBar );

			setList(list);
			
			this.pack();
			this.setVisible(true);
		}

		/* (non-Javadoc)
		 * @see org.one.stone.soup.swing.JRootFrame#destroy()
		 */
		public boolean destroy() {

			setVisible(false);
			dispose();

			return false;
		}

		public void actionPerformed(ActionEvent action)
		{
			String command = action.getActionCommand().toLowerCase();

			if( command.equals("clear") )
			{
				textConsole.clear();
			}
			else if( command.equals("find") )
			{
				String selected = textConsole.getSelected();
				if(selected==null)
				{
					selected="";
				}

				String find = JOptionPane.showInputDialog(this,"Find",selected);
				textConsole.find(find);
			}
			else if( command.equals("replace") )
			{
				String selected = textConsole.getSelected();
				if(selected==null)
				{
					selected="";
				}

				String find = JOptionPane.showInputDialog(this,"Find",selected);
				String replace = JOptionPane.showInputDialog(this,"Replace With");

				textConsole.replace(find,replace);
			}
			else if( command.equals("distinct") )
			{
				String data = textConsole.getText();

				String[] items = StringArrayHelper.parseFields(data,"\n\r");

				System.out.println(items.length);

				Hashtable hash = new Hashtable();
				for(int loop=0;loop<items.length;loop++)
				{
					hash.put(items[loop],items[loop]);
				}
				Object[] itemObjects = hash.keySet().toArray();
				items = new String[ itemObjects.length ];
				for(int loop=0;loop<items.length;loop++)
				{
					items[loop] = itemObjects[loop].toString();
				}
				items = StringArrayHelper.sort( items,StringArrayHelper.ASCENDING );

				System.out.println(items.length);

				data = StringArrayHelper.arrayToString(items,"\n");

				textConsole.setText(data);
			}
			else if( command.equals("sort ascending") )
			{
				String data = textConsole.getText();

				String[] items = StringArrayHelper.parseFields(data,"\n\r");
				items = StringArrayHelper.sort( items,StringArrayHelper.ASCENDING );
				data = StringArrayHelper.arrayToString(items,"\n");

				textConsole.setText(data);
			}
			else if( command.equals("sort descending") )
			{
				String data = textConsole.getText();

				String[] items = StringArrayHelper.parseFields(data,"\n\r");
				items = StringArrayHelper.sort( items,StringArrayHelper.DESCENDING );
				data = StringArrayHelper.arrayToString(items,"\n");

				textConsole.setText(data);

			}
		}

		public void setList(Vector list)
		{
			StringBuffer buffer = new StringBuffer();
			for(int loop=0;loop<list.size();loop++)
			{
				buffer.append(list.elementAt(loop));
				buffer.append('\n');
			}

			textConsole.setText( buffer.toString() );
		}
		
		public Vector getList()
		{
			return StringArrayHelper.stringArrayToVector( StringArrayHelper.parseFields(textConsole.getText(),'\n') );
		}

	}
