package org.one.stone.soup.xapp.helper;

import java.util.Vector;

import org.one.stone.soup.xml.XmlElement;
import org.one.stone.soup.xml.stream.XmlLoader;

public class XappToHTML {
private XappToHTML() {
	super();
}
public static XmlElement convertAnchor(XmlElement xData,Vector resources)
{
//	String name = xData.getAttributeValueByName("name");
	String href = xData.getAttributeValueByName("href");
	String command = xData.getAttributeValueByName("command");

	XmlElement anchor = new XmlElement("a");
	anchor.addAttribute("class","xuiAnchor");
	anchor.addValue(xData.getValue());

//	setBackground(anchor,xData);
//	setColor(anchor,xData);
//	setTip(anchor,xData);

	if(command!=null)
	{
		anchor.addAttribute("href","javascript:processCommand('"+command+"');");
	}
	else
	{
		anchor.addAttribute("href",href);
	}

	return anchor;
}
public static XmlElement convertComponent(Object data,Vector resources) {

	if(data instanceof String)
	{
		XmlElement label = new XmlElement("font");
		label.addValue((String)data);
		return label;
	}
	if(data instanceof XmlElement && ((XmlElement)data).getName().equals("td"))
	{
		XmlElement xData = (XmlElement)data;

		XmlElement label = new XmlElement("font");

		for(int loop=0;loop<xData.getElementCount();loop++)
		{
			if(loop>0)
			{
				label.addChild("BR");
			}

			label.addValue(xData.getValue(loop));
		}
		return label;
	}
	else if(data instanceof XmlElement)
	{
		XmlElement xData = (XmlElement)data;
		if(xData.getName().equals("h"))
		{
			return convertHeading( xData,resources );
		}
		if(xData.getName().equals("label"))
		{
			return convertLabel( xData,resources );
		}
		if(xData.getName().equals("a"))
		{
			return convertAnchor( xData,resources );
		}
		if(xData.getName().equals("input"))
		{
			return convertInput( xData,resources );
		}
		else if(xData.getName().equals("select"))
		{
			return convertSelect( xData,resources );
		}
		else if(xData.getName().equals("textarea"))
		{
			return convertTextArea( xData,resources );
		}
		else if(xData.getName().equals("table"))
		{
			StringBuffer buffer = new StringBuffer();
			convertTable(xData,buffer);
			try{
				return XmlLoader.getStandardParser().parseElement(buffer.toString());
			}
			catch(Exception e)
			{
				return null;
			}
		}
		else if(xData.getName().equals("img"))
		{
			return convertImageIcon( "src",xData,resources );
		}
	}

	return null;
}
public static XmlElement convertHeading(XmlElement xData,Vector resources)
{
	String value = xData.getValue();

	String size = xData.getAttributeValueByName("size");
	String face = xData.getAttributeValueByName("face");
	String style = xData.getAttributeValueByName("style");
	String color = xData.getAttributeValueByName("color");

	XmlElement label = new XmlElement("font");
	label.addAttribute("class","xuiHeading");
	label.addAttribute("size",""+(Integer.parseInt(size)/5));
	label.addAttribute("face",face);

	if(color!=null)
	{
		label.addAttribute("color",color);
	}

	if(style!=null)
	{
		if(style.equals("BOLD"))
		{
			label.addChild("b").addValue(value);
		}
		else if(style.equals("ITALIC"))
		{
			label.addChild("i").addValue(value);
		}
		else if(style.equals("BOLD-ITALIC"))
		{
			label.addChild("b").addChild("i").addValue(value);
		}
		else
		{
			label.addValue(value);
		}
	}
	else
	{
		label.addValue(value);
	}

	return label;
}
public static XmlElement convertImageIcon(String attributeName,XmlElement xData,Vector resources)
{
	String src = xData.getAttributeValueByName(attributeName);

	XmlElement img = new XmlElement("img");
	img.addAttribute("class","xuiImage");
	img.addAttribute("border","0");
	img.addAttribute("src",src);

	resources.addElement(src);

	return img;
}
public static XmlElement convertInput(XmlElement xData,Vector resources)
{
	String type = xData.getAttributeValueByName("type");

	if(type.equals("slider"))
	{
		//return buildSlider( container,xData );
		return null;
	}
	else if(type.equals("progress"))
	{
		//return buildProgress( container,xData );
		return null;
	}
	else if(type.equals("color"))
	{
		/*JColorChooser color = new JColorChooser();

		String name = xData.getAttributeValueByName("name");
		color.setName( name );
		setBackground(color,xData);
		setColor(color,xData);

		container.addElement(color);*/

		return null;
	}
	else if( type.equals("text") )
	{
		int size = 10;
		String sizeV = xData.getAttributeValueByName("size");
		if(sizeV!=null)
		{
			size = Integer.parseInt(sizeV);
		}
		String name = xData.getAttributeValueByName("name");

		XmlElement text = new XmlElement("input");
		text.addAttribute("class","xuiInputText");
		text.addAttribute("type","TEXT");
		text.addAttribute("name",""+name);
		text.addAttribute("size",""+size);

		String data = xData.getAttributeValueByName("value");
		if(data!=null)
		{
			text.addAttribute("value",data);
		}

//		setBackground(text,xData);
//		setColor(text,xData);
//		setTip(text,xData);

		return text;
	}
	else if( type.equals("file") )
	{
		String name = xData.getAttributeValueByName("name");

		XmlElement file = new XmlElement("input");
		file.addAttribute("class","xuiInputFile");
		file.addAttribute("type","FILE");
		file.addAttribute("name",""+name);

		String data = xData.getAttributeValueByName("value");
		if(data!=null)
		{
			file.addAttribute("value",data);
		}

//		setBackground(file,xData);
//		setColor(file,xData);
//		setTip(file,xData);

		return file;
	}
	else if( type.equals("password") )
	{
		int size = 10;
		String sizeV = xData.getAttributeValueByName("size");
		if(sizeV!=null)
		{
			size = Integer.parseInt(sizeV);
		}
		String name = xData.getAttributeValueByName("name");

		XmlElement text = new XmlElement("input");
		text.addAttribute("class","xuiInputPassword");
		text.addAttribute("type","PASSWORD");
		text.addAttribute("name",""+name);
		text.addAttribute("size",""+size);

//		setBackground(text,xData);
//		setColor(text,xData);
//		setTip(text,xData);

		return text;
	}
	else if( type.equals("checkbox") )
	{
		String name = xData.getAttributeValueByName("name");

		XmlElement check= new XmlElement("input");
		check.addAttribute("class","xuiInputCheckbox");
		check.addAttribute("type","CHECKBOX");
		check.addAttribute("name",""+name);

		//check.setIcon( new ImageIcon(ImageFactory.getWAIT()) );
		//check.setSelectedIcon( new ImageIcon(ImageFactory.getDOG()) );
//		if(setBackground(check,xData)==false)
//		{
//			check.setBackground(container.getBackground());
//		}
//		if(setColor(check,xData)==false)
//		{
//			check.setForeground(container.getForeground());
//		}
//		setTip(check,xData);

		return check;
	}
	else if( type.equals("button") )
	{
		String name = xData.getAttributeValueByName("name");
		String value = xData.getAttributeValueByName("value");

		XmlElement button = new XmlElement("button");
		button.addAttribute("class","xuiInputButton");
		button.addAttribute("name",name);

//		button.setActionCommand("false");

//		button.addActionListener( container );
//		setBackground(button,xData);
//		setColor(button,xData);
//		setTip(button,xData);

		return button;
	}
	else if( type.equals("imgButton") )
	{
		String name = xData.getAttributeValueByName("name");
		String value = xData.getAttributeValueByName("value");

		XmlElement button = convertImageIcon("icon",xData,resources);
		button.addAttribute("class","xuiInputImageButton");

/*		button.setName(name);
		button.setBorderPainted(false);
		button.setBorder(null);
		button.setContentAreaFilled(false);
		button.setFocusPainted(false);

		button.setIcon( getImageIcon("icon",xData) );
		button.setDisabledIcon( getImageIcon("disabledIcon",xData) );
		button.setPressedIcon( getImageIcon("selectedIcon",xData) );

		setBackground(button,xData);
		setColor(button,xData);
		setTip(button,xData);

		button.setActionCommand("false");
		button.addActionListener( container );*/

		return button;
	}
/*	else if( type.equals("radio") )
	{
		String group = xData.getAttributeValueByName("group");

		String name = xData.getAttributeValueByName("name");

		JRadioButton radio = new JRadioButton();
		radio.setName(name);
		if(setBackground(radio,xData)==false)
		{
			radio.setBackground(container.getBackground());
		}
		if(setColor(radio,xData)==false)
		{
			radio.setForeground(container.getForeground());
		}
		setTip(radio,xData);

		container.addGroupMember(group,radio);
		radio.setActionCommand(group);
		radio.addActionListener(container);

		return radio;
	}
	else if( type.equals("submit") )
	{
		String value = xData.getAttributeValueByName("value");

		JButton button = new JButton(value);
		button.setName("submit");
		button.addActionListener( container );
		setBackground(button,xData);
		setColor(button,xData);
		setTip(button,xData);

		return button;
	}*/

	return null;
}
public static XmlElement convertLabel(XmlElement xData,Vector resources)
{
		String data = xData.getValue();
		String name = xData.getAttributeValueByName("name");

		XmlElement label = new XmlElement("font");

//		setBackground(label,xData);
//		setColor(label,xData);
//		setTip(label,xData);

		label.addValue(data);

		return label;
}
public static XmlElement convertProgress(XmlElement xData,Vector resources)
{
/*	String name = xData.getAttributeValueByName("name");
	int min = Integer.parseInt(xData.getAttributeValueByName("min"));
	int max = Integer.parseInt(xData.getAttributeValueByName("max"));
	int value = Integer.parseInt(xData.getAttributeValueByName("value"));

	JProgressBar progress = new JProgressBar(min,max);
	progress.setName(name);
	progress.setValue(value);

	progress.setStringPainted(true);

	setBackground(progress,xData);
	setColor(progress,xData);
	setTip(progress,xData);

	container.addElement(progress);

	return progress;
*/
	return null;
}
public static XmlElement convertSelect(XmlElement xData,Vector resources)
{
	String name = xData.getAttributeValueByName("name");

	XmlElement list = new XmlElement("select");
	list.addAttribute("class","xuiSelect");

	Vector options = xData.getElementsByName("option");

	for(int loop=0;loop<options.size();loop++)
	{
		list.addChild("option").addValue( ((XmlElement)options.elementAt(loop)).getValue() );
	}

	list.addAttribute("name",name);
//	setBackground(list,xData);
//	setColor(list,xData);
//	setTip(list,xData);

	return list;
}
public static XmlElement convertSlider(XmlElement xData,Vector resources)
{
/*	String name = xData.getAttributeValueByName("name");
	int min = Integer.parseInt(xData.getAttributeValueByName("min"));
	int max = Integer.parseInt(xData.getAttributeValueByName("max"));
	int value = Integer.parseInt(xData.getAttributeValueByName("value"));

	JSlider slider = new JSlider(min,max,value);
	slider.setName(name);

	slider.setMinorTickSpacing( (max-min)/10 );
	slider.setMajorTickSpacing( (max-min)/5 );

	slider.setPaintLabels(true);
	slider.setPaintTicks(true);
	slider.setPaintTrack(true);

	setBackground(slider,xData);
	setColor(slider,xData);
	setTip(slider,xData);

	container.addElement(slider);

	return slider;*/
	return null;
}
public static Vector convertTable(XmlElement table,StringBuffer buffer)
{
	Vector resources = new Vector();

	String name = table.getAttributeValueByName("name");
	if(name!=null)
	{
		buffer.append("<FORM name='"+name+"'>");
	}

	XmlElement htmlTable = new XmlElement("table");
	htmlTable.addAttribute("class","xuiTable");
	htmlTable.addAttribute("cellpadding","0");
	htmlTable.addAttribute("cellspacing","0");
	setBackground(htmlTable,table);
	// add table attributes

	Vector xRows = table.getElementsByName("tr");

	for(int loopR=0;loopR<xRows.size();loopR++)
	{
		XmlElement htmlRow = htmlTable.addChild("tr");
		htmlRow.addAttribute("class","xuiRow");

		XmlElement xRow = (XmlElement)xRows.elementAt(loopR);
		Vector xCols = xRow.getElementsByName("td");

		for(int loopC=0;loopC<xCols.size();loopC++)
		{
			XmlElement xCol = (XmlElement)xCols.elementAt(loopC);

			XmlElement htmlCell = htmlRow.addChild("td");
			setBackground(htmlCell,xCol);

			name = xCol.getAttributeValueByName("name");
			if(name==null)
			{
				name = "r"+loopR+"c"+loopC;
				htmlCell.addAttribute("class","xuiCell");
			}
			else
			{
				htmlCell.addAttribute("class",name.replace(' ','-'));
			}

			String align = xCol.getAttributeValueByName("align");
			String valign = xCol.getAttributeValueByName("valign");
			String height = xCol.getAttributeValueByName("height");
			String width = xCol.getAttributeValueByName("width");
			String colspan = xCol.getAttributeValueByName("colspan");

			if(align!=null && align.length()>0)
			{
				htmlCell.addAttribute("align",align);
			}
			if(valign!=null && valign.length()>0)
			{
				htmlCell.addAttribute("valign",valign);
			}
			if(height!=null && height.length()>0)
			{
				htmlCell.addAttribute("height",height);
			}
			if(width!=null && width.length()>0)
			{
				htmlCell.addAttribute("width",width);
			}
			if(colspan!=null && colspan.length()>0)
			{
				htmlCell.addAttribute("colspan",colspan);
			}

			if(xCol.getElementCount()==0)
			{
				htmlCell.addValue(" ");
			}
			else if(xCol.getElementCount()==1)
			{
				Object data = xCol.getData(0);

				if( data!=null )
				{
					XmlElement comp = convertComponent( data,resources );

					htmlCell.addChild(comp);
				}
			}
			else if (xCol.getElementCount()>1)
			{
				Object data = xCol.getElements();

				if( data!=null )
				{
					XmlElement comp = convertComponent( xCol,resources );

					htmlCell.addChild(comp);
				}
			}
		}
	}

	buffer.append( htmlTable.toXml() );

	if(name!=null)
	{
		buffer.append("</FORM>");
	}

	return resources;
}
public static XmlElement convertTextArea(XmlElement xData,Vector resources)
{
	String name = xData.getAttributeValueByName("name");
	String editable = xData.getAttributeValueByName("editable");
	int cols = Integer.parseInt(xData.getAttributeValueByName("cols"));
	int rows = Integer.parseInt(xData.getAttributeValueByName("rows"));

	XmlElement text = new XmlElement("textarea");
	text.addAttribute("class","xuiTextArea");
	text.addAttribute("name",name);
	text.addAttribute("cols",""+cols);
	text.addAttribute("rows",""+rows);
	if(editable.equals("false"))
	{
		text.addAttribute("readonly","true");
	}

	StringBuffer buffer = new StringBuffer();
	for(int loop=0;loop<xData.getElementCount();loop++)
	{
		buffer.append(xData.getData(loop)+"\n");
	}
	text.addValue(buffer.toString());

	return text;
}
public static Vector convertTree(XmlElement element,StringBuffer buffer)
{
/*
	DefaultMutableTreeNode node = new DefaultMutableTreeNode();// elementName );
	node.setUserObject(element);

	if(element.getElementCount()==0)
	{
		node.setAllowsChildren(true);
	}

	for(int loop=0;loop<element.getElementCount();loop++)
	{
		XmlElement child = element.getElementByIndex(loop);

		if(child!=null)
		{
			node.add( buildTree(child) );
		}
		else
		{
			Object data = element.getData(loop);

			if(data instanceof String)
			{
				DefaultMutableTreeNode dataNode = new DefaultMutableTreeNode();// (String)data );

				node.add(dataNode);
				dataNode.setUserObject(data);
			}
		}
	}

	return node;*/

	return null;
}
public static boolean setBackground(XmlElement target,XmlElement source)
{
	String bgColor = source.getAttributeValueByName("bgcolor");
	if(bgColor!=null)
	{
		target.addAttribute("bgcolor",bgColor);
		return true;
	}
	return false;
}
public static boolean setColor(XmlElement target,XmlElement source)
{
	String color = source.getAttributeValueByName("color");
	if(color!=null)
	{
		target.addAttribute("color",color);
		return true;
	}
	return false;
}
public static void setTip(XmlElement target,XmlElement source)
{
	String tip = source.getAttributeValueByName("tip");
	if(tip!=null)
	{
		target.addAttribute("alt",tip);
	}
}
}
