package org.one.stone.soup.xapp.swing.components;

import java.util.Vector;

import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.border.BevelBorder;
import javax.swing.border.SoftBevelBorder;

import org.one.stone.soup.entity.KeyValuePair;
import org.one.stone.soup.xapp.components.XappSelectionField;

public class XappSwingSelectionField extends JComboBox implements
		XappSelectionField {

	private Vector options = new Vector();
	
	public XappSwingSelectionField()
	{
		((JButton)getComponent(0)).setBorder( new SoftBevelBorder(BevelBorder.RAISED) );
	}
	
	public KeyValuePair[] getOptions() {
		return (KeyValuePair[])options.toArray(new KeyValuePair[]{});
	}

	public boolean hasOptions() {
		if(options.size()==0)
		{
			return false;
		}
		else
		{
			return true;
		}
	}

	public void addOption(KeyValuePair option) {
		options.add(option);
		super.addItem(option);
	}

	public void appendOptions(KeyValuePair[] newOptions) {
		for(int loop=0;loop<newOptions.length;loop++)
		{
			options.add(newOptions[loop]);
			super.addItem(newOptions[loop]);
		}
	}

	public String getData() {
		Object selectedItem = getSelectedItem();
		if(selectedItem!=null)
		{
			if(selectedItem instanceof KeyValuePair)
			{
				return ((KeyValuePair)getSelectedItem()).value;
			}
			else
			{
				return getSelectedItem().toString();
			}
		}
		else
		{
			return "";
		}
	}

	public void setData(String value) {
		for(int loop=0;loop<options.size();loop++)
		{
			if( ((KeyValuePair)options.elementAt(loop)).value.equals(value) )
			{
				super.setSelectedIndex(loop);
			}
		}

	}

	public void setTip(String toolTip) {
		// TODO Auto-generated method stub

	}

}
