package org.one.stone.soup.xapp.swing.dnd;

import java.awt.*;
import java.awt.dnd.*;
import java.awt.datatransfer.*;

import org.one.stone.soup.xapp.*;
import org.one.stone.soup.xapp.dnd.XappDropReceiver;
import org.one.stone.soup.xml.*;
/**
 * Insert the type's description here.
 * Creation date: (17/05/03 12:22:11)
 * @author:
 */
public class XappSwingDropReceiver implements DropTargetListener, XappDropReceiver
{
	private XappReceiver receiver;
	private String name;
	private String action;
	private DropTarget dropTarget;
/**
 * XDropReceiver constructor comment.
 */
public XappSwingDropReceiver(Component target,XappReceiver receiver,String name,String action) {
	super();

	this.receiver = receiver;
	this.name = name;
	this.action = action;

	dropTarget = new DropTarget(target,this);
}
/**
 * Insert the method's description here.
 * Creation date: (11/06/03 12:35:31)
 */
public void dispose()
{
	dropTarget.setActive(false);
	dropTarget=null;
	receiver = null;
	name = null;
}
	/**
	 * Called when a drag operation has
	 * encountered the <code>DropTarget</code>.
	 * <P>
	 * @param dtde the <code>DropTargetDragEvent</code>
	 */
public void dragEnter(java.awt.dnd.DropTargetDragEvent dtde) {}
	/**
	 * The drag operation has departed
	 * the <code>DropTarget</code> without dropping.
	 * <P>
	 * @param dte the <code>DropTargetEvent</code>
	 */
public void dragExit(java.awt.dnd.DropTargetEvent dte) {}
	/**
	 * Called when a drag operation is ongoing
	 * on the <code>DropTarget</code>.
	 * <P>
	 * @param dtde the <code>DropTargetDragEvent</code>
	 */
public void dragOver(java.awt.dnd.DropTargetDragEvent dtde) {}
	/* (non-Javadoc)
	 * @see org.one.stone.soup.xapp.dnd.XappDropReceiver#drop(java.awt.dnd.DropTargetDropEvent)
	 */
public void drop(java.awt.dnd.DropTargetDropEvent dtde)
{
	DataFlavor df[] = dtde.getTransferable().getTransferDataFlavors();

	int loop=0;
	for(loop=0;loop<df.length;loop++)
	{
		//System.out.println("DnD DataFlavor:"+df[loop]);
		if(
				df[loop].equals(DataFlavor.javaFileListFlavor)
				//|| df[loop].isMimeTypeEqual("application/x-java-url")
		)
		{
			break;
		}
	}

	if(loop==df.length)
	{
		return;
	}

	try{
		dtde.acceptDrop(DnDConstants.ACTION_COPY);

		if( df[loop].equals(DataFlavor.javaFileListFlavor) )
		{
			java.util.List list = (java.util.List)dtde.getTransferable().getTransferData( java.awt.datatransfer.DataFlavor.javaFileListFlavor );

			XmlElement xList = new XmlElement("drop");
			xList.addAttribute("name",name);
			Point position = dtde.getLocation();
			xList.addAttribute("x",""+position.x);
			xList.addAttribute("y",""+position.y);

			for(loop=0;loop<list.size();loop++)
			{
				String fileName = list.get(loop).toString();

				xList.addChild("file").addValue(fileName);
			}

			dtde.dropComplete(true);

			receiver.receiveXappData(xList);
			
			if(action!=null)
			{
				XmlElement xAction = new XmlElement("action");
				xAction.addChild("drop").addValue(action);
				receiver.receiveXappData( xAction );
			}
		}
		/*else if( df[loop].isMimeTypeEqual("application/x-java-url") )
		{
			DataFlavor flavor = new DataFlavor( Class.forName("java.net.URL"),"application/x-java-url" );
			dtde.getTransferable().;
		}*/
	}
	catch(Exception e)
	{
		e.printStackTrace();
	}
}
	/**
	 * Called if the user has modified
	 * the current drop gesture.
	 * <P>
	 * @param dtde the <code>DropTargetDragEvent</code>
	 */
public void dropActionChanged(java.awt.dnd.DropTargetDragEvent dtde) {}
/* (non-Javadoc)
 * @see org.one.stone.soup.xapp.dnd.XappDropReceiver#getDropTarget()
 */
public Component getDropTarget() {
	return dropTarget.getComponent();
}
/* (non-Javadoc)
 * @see org.one.stone.soup.xapp.dnd.XappDropReceiver#setDropTarget(java.awt.Component)
 */
public void setDropTarget(Component target) {
	dropTarget = new DropTarget(target,this);
}
}
